VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Limacon"
   ClientHeight    =   3975
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3240
   LinkTopic       =   "Form1"
   ScaleHeight     =   3975
   ScaleWidth      =   3240
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   1200
      TabIndex        =   5
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtB 
      Height          =   285
      Left            =   360
      TabIndex        =   4
      Text            =   "5"
      Top             =   480
      Width           =   615
   End
   Begin VB.TextBox txtA 
      Height          =   285
      Left            =   360
      TabIndex        =   2
      Text            =   "3"
      Top             =   120
      Width           =   615
   End
   Begin VB.PictureBox picGraph 
      Height          =   3015
      Left            =   120
      ScaleHeight     =   2955
      ScaleWidth      =   2955
      TabIndex        =   0
      Top             =   840
      Width           =   3015
   End
   Begin VB.Label Label1 
      Caption         =   "B"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   255
   End
   Begin VB.Label Label1 
      Caption         =   "A"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdGo_Click()
    DrawCurve
End Sub

Private Sub DrawCurve()
Const PI = 3.14159265
Dim A As Single
Dim B As Single
Dim x As Single
Dim y As Single
Dim r As Single
Dim t As Single
Dim dt As Single

    picGraph.AutoRedraw = True
    picGraph.Cls

    A = CSng(txtA.Text)
    B = CSng(txtB.Text)

    ' Set a convenient scale.
    If A < B Then
        picGraph.ScaleLeft = -1 - 0.25
        picGraph.ScaleWidth = 1 + A + B + 0.5
    Else
        picGraph.ScaleLeft = B - A - 0.25
        picGraph.ScaleWidth = 2 * A + 0.5
    End If
    picGraph.ScaleLeft = picGraph.ScaleLeft * 1.5
    picGraph.ScaleWidth = picGraph.ScaleWidth * 1.5
    picGraph.ScaleTop = picGraph.ScaleWidth / 2
    picGraph.ScaleHeight = -picGraph.ScaleWidth

    ' Draw axes.
    picGraph.Line (picGraph.ScaleLeft, 0)-Step(picGraph.ScaleWidth, 0), vbBlue
    x = Int(picGraph.ScaleLeft)
    Do While x <= picGraph.ScaleLeft + picGraph.ScaleWidth
        picGraph.Line (x, -0.2)-(x, 0.2), vbBlue
        x = x + 1
    Loop

    picGraph.Line (0, picGraph.ScaleTop)-Step(0, picGraph.ScaleHeight), vbBlue
    y = Int(picGraph.ScaleTop)
    Do While y >= picGraph.ScaleTop + picGraph.ScaleHeight
        picGraph.Line (-0.2, y)-(0.2, y), vbBlue
        y = y - 1
    Loop

    picGraph.Line (0, -5)-(0, 5), vbBlue
    For y = -5 To 5
        picGraph.Line (-0.2, y)-(0.2, y), vbBlue
    Next y

    ' Draw the parametric curve.
    t = 0
    dt = PI / 100
    r = A + B * Cos(t)
    picGraph.CurrentX = r * Cos(t)
    picGraph.CurrentY = r * Sin(t)

    Do While t <= 2 * PI
        r = A + B * Cos(t)
        x = r * Cos(t)
        y = r * Sin(t)
        picGraph.Line -(x, y)
        t = t + dt
    Loop

    t = 0
    r = A + B * Cos(t)
    picGraph.CurrentX = r * Cos(t)
    picGraph.CurrentY = r * Sin(t)
    picGraph.Line -(x, y)
End Sub

